
#include <stdio.h> 
#include <stdlib.h>
#include <string.h>

/*
 * htmlencode.c -- html-related utilities.
 * $Id: htmlencode.c,v 1.0 2008/01/21 09:00:00 Grandville Exp $
 * 
 * Copyright (C) 2008 Grandville Arnaud
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 *  gcc -lstdc++ -o htmlencode htmlencode.cpp
 * 
 */

static const char * const html_code_map[256] = {
   NULL,   "",   "",   "",   "",   "",   "",   "",   "",   "",
     "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
     "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
     "",   "", NULL, NULL, NULL, NULL, NULL, NULL,"&amp;","&quot;",
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   "&lt;",NULL,"&gt;",NULL,NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL
};


int html_encode(char* szBuffer,int iLength){
	int iNewLength = 0;
	char* szPos = szBuffer;
	unsigned char c;
	int iDelta = 0;
	
	// - calcul de la nouvelle taille en
	//   tenant compte des caractres spciaux
	// - les caractres de contrle sont supprims
	while ( (c =*(szPos+iDelta)) != 0 && iNewLength<iLength){
		
		if(html_code_map[(unsigned char) c]==NULL){
			//printf("%i:%i(%c) +%i\n",iNewLength,c,c,iDelta);
			iNewLength++;
			szPos++;
		}else{
			if(strlen(html_code_map[(unsigned char) c]) ==0){
				//printf("%i:%i(ESC) +%i\n",iNewLength,c,iDelta);
				iDelta++;
			} else {
				//printf("%i:%i(%c) +%i\n",iNewLength,c,c,iDelta);
				iNewLength+=strlen(html_code_map[(unsigned char) c]);
				szPos++;
			}
		}
		*szPos = *(szPos+iDelta);

	}
	*(szPos)='\0';
	

//	szPos=szBuffer;
//	for(int a=0;a<=iLength-iDelta;a++){
//		printf("%i %c \n",a,szPos[a]);
//	}
	
	// si le buffer de destination est assez grand
	//printf("iNewLength %i iLength %i\n",iNewLength,iLength);
	if(iNewLength<iLength){
		// parcours en sens inverse du buffer d'origine et
		// copie des caractres  leur nouvelle position
		while(szPos>=szBuffer){
			c =*szPos;
			//printf("%i:char:%i(%c)\n",iNewLength,c,c);
			if(html_code_map[(unsigned char) c]==NULL){
				// il s'agit d'un caractre sur une position
				// le pointeur se dplace d'une position
				szBuffer[iNewLength]=*szPos;
				iNewLength--;
			}else{
				// il s'agit d'une chaine sur plusieurs positions
				// le pointeur se dplace donc de plusieurs positions
				//printf("new len:%i\n",strlen(html_code_map[(unsigned char) c]));
				iNewLength-=strlen(html_code_map[(unsigned char) c])-1;
				memcpy(&szBuffer[iNewLength],html_code_map[(unsigned char) c],strlen(html_code_map[(unsigned char) c]));
				iNewLength--;
			}
			szPos--;
		}
		return 1;
	} 
	
	return 0;
}


int main(void){
	
	char szBuffer[100];
	
	sprintf(szBuffer,"%s","<item>abcd\"efg\'gij</item>");

	if(html_encode(szBuffer,100))
		printf("%s\n",szBuffer);

	sprintf(szBuffer,"%s","a\f\f\f<bcdefg");
	if(html_encode(szBuffer,40))
		printf("%s\n",szBuffer);

	sprintf(szBuffer,"%s","ab<> cdefgh\b\b\b<>");
	if(html_encode(szBuffer,30))
		printf("%s\n",szBuffer);

	sprintf(szBuffer,"%s","ab<>cdefgh\b\b\b<>");
	html_encode(szBuffer,10);
	printf("%s\n",szBuffer);
	return 0;
}
